#include "headers\\camera.h"
#include<gl/glut.h>
Camera::Camera()
{
	xp=0;
	yp=0;
	zp=0;
	ViewAngleX=0;
	ViewAngleZ=2.27;
}
Camera::~Camera()
{
}

void Camera::UpdateCamera()
{
	
	Rotation.rotationmatrix(ViewAngleX,ViewAngleZ,0);
	multiplymatrixes(&Rotation,&Translation);
	invertmatrix();
	convertmatrix();
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glLoadMatrixf(SinglecMatrix);


}

void Camera::MoveCamera(float Amount)
{
	xp+=Translation.Matrixd[0][3]+=(Rotation.Matrixd[2][0]*Amount);
	yp+=Translation.Matrixd[1][3]+=(Rotation.Matrixd[2][1]*Amount);
	zp+=Translation.Matrixd[2][3]+=(Rotation.Matrixd[2][2]*Amount);
}

void Camera::TurnCamera(float x,float y)
{
	ViewAngleX+=x*0.017453292519943295769236907684886;//Convert to radians and save
	ViewAngleZ+=y*0.017453292519943295769236907684886;//Convert to radians and save
}
void Camera::CreateLightView(float lightposx,float lightposy,float lightposz,double LightAngleX,double LightAngleZ)
{
	
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	TurnCamera(0,0);
	xp=lightposx;
	yp=lightposy;
	zp=lightposz;
	
	Translation.Matrixd[0][3]=xp;
	Translation.Matrixd[1][3]=yp;
	Translation.Matrixd[2][3]=zp;

	ViewAngleX=LightAngleX;
	ViewAngleZ=LightAngleZ;
	MoveCamera(0);
	TurnCamera(0,0);
	UpdateCamera();
}
void Camera::RestoreFromLightView()
{	

	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
}
void Camera::KeepCentered()
{
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glTranslatef(-Translation.Matrixd[0][3],-Translation.Matrixd[1][3],-Translation.Matrixd[2][3]);
	
}