#include "headers\\Cg.h"
#include <stdio.h>
void cgErrorCallback();
CgShader::CgShader(char *ShaderFileName,bool VertexProgram)
{
	if(NumberOfShaders==0)
	{
			context = cgCreateContext();
		
	}
	cgSetErrorCallback(cgErrorCallback);
	ProgramType=VertexProgram;
	if(VertexProgram==true)
	 Programs = cgCreateProgramFromFile(context, CG_SOURCE, ShaderFileName,
		CG_PROFILE_ARBVP1, NULL, NULL);
	else
	Programs = cgCreateProgramFromFile(context, CG_SOURCE, ShaderFileName,
		CG_PROFILE_FP20, NULL, NULL);
	if (!cgIsProgramCompiled(Programs))
		cgCompileProgram(Programs);
	
	if(VertexProgram==true)
	{
		cgGLEnableProfile(CG_PROFILE_ARBVP1);
		cgGLLoadProgram(Programs);
	}
	else
	{
		cgGLEnableProfile(CG_PROFILE_FP20);
		cgGLLoadProgram(Programs);
	}
	usedtextureparams=0;
	NumberOfShaders++;
}
void cgErrorCallback()
{
  CGerror lastError = cgGetError();
  
  if(lastError)
  {
    printf("%s\n\n", cgGetErrorString(lastError));
    printf("%s\n", cgGetLastListing(context));
    printf("Cg error, exiting...\n");
    
   
  }
} 
CgShader::~CgShader()
{
	cgDestroyProgram(Programs);
	NumberOfShaders--;
	if(NumberOfShaders==0)
		cgDestroyContext(context);
}
void CgShader::GetDebugInfo()
{	
	const char* errormessage=cgGetLastListing(context);
	
	MessageBox(0,errormessage,"error",MB_OK);
	
	const char* Program=cgGetProgramString(Programs,CG_COMPILED_PROGRAM);

	MessageBox(0,Program,"Program",MB_OK);
}
void CgShader::SetProgramParameterValue1(char *ParameterName,float *Value)
{
	cgGLSetParameter1fv(cgGetNamedParameter(Programs, ParameterName),Value);
}
void CgShader::SetProgramParameterValue4(char *ParameterName,float *Value)
{
	cgGLSetParameter4fv(cgGetNamedParameter(Programs, ParameterName),Value);
}
void CgShader::SetTextureParameterValue(char*TextureName,GLuint Texture)
{
	texparam[usedtextureparams]=cgGetNamedParameter(Programs, TextureName);
	TexIDs[usedtextureparams]=Texture;
	usedtextureparams++;//Keep track of all the textures used with this shader
}
void CgShader::BindProgram()
{

    
	if(ProgramType==true)
	{
	
	cgGLSetStateMatrixParameter(cgGetNamedParameter(Programs, "ModelViewProj"),
		CG_GL_MODELVIEW_PROJECTION_MATRIX,
		CG_GL_MATRIX_IDENTITY);
	
	cgGLSetStateMatrixParameter(cgGetNamedParameter(Programs, "InvModelViewMatrix"),
		CG_GL_MODELVIEW_MATRIX,
		CG_GL_MATRIX_INVERSE);


	cgGLSetStateMatrixParameter(cgGetNamedParameter(Programs, "TextureMatrix"),
		CG_GL_TEXTURE_MATRIX,
		CG_GL_MATRIX_IDENTITY);


	cgGLEnableProfile(CG_PROFILE_ARBVP1);
	cgGLBindProgram(Programs);
	}
	if(ProgramType==false)
	{
		cgGLEnableProfile(CG_PROFILE_FP20);
		cgGLBindProgram(Programs);
		for(int i=0;i<usedtextureparams;i++)
		{
			cgGLSetTextureParameter(texparam[i],TexIDs[i]);
			cgGLEnableTextureParameter(texparam[i]);
		}
	}

}
void CgShader::DisableProfile()
{

	if(ProgramType==true)
		cgGLDisableProfile(CG_PROFILE_ARBVP1);
	else
	{
		cgGLDisableProfile(CG_PROFILE_FP20);
		for(int i=0;i<usedtextureparams;i++)
		{
			cgGLDisableTextureParameter(texparam[i]);
		}
	}
}