
#include "headers\\landscape.h"
#include "headers\\Characters.h"
Characters::Characters(char *filename,char *texturefilename)
{
	LoadModel(filename);
	LoadSkin( texturefilename );
	SetAnim( STAND );
	ScaleModel( 0.15 );
	x=0;
	y=0;
	z=0;
	angle=0;
	InternalTime=0;
	CurState=STAND;
	hasweapon=false;

}
void Characters::LoadWeapon(char *filename,char *texturefilename)
{

	Weapon.LoadModel(filename);
	Weapon.LoadSkin( texturefilename );
	Weapon.SetAnim( STAND );
	Weapon.ScaleModel( 0.15 );
	hasweapon=true;
}
void Characters::Render()

{
	glPushMatrix();
	glEnable(GL_TEXTURE_2D);
	glTranslatef( y, z, x);
	glRotatef( -90.0, 1.0, 0.0, 0.0 );
	glRotatef(angle-90,0,0,1);
	DrawModel(InternalTime);
	if(hasweapon==true)
		Weapon.DrawModel(InternalTime);

	glPopMatrix();
	glDisable(GL_TEXTURE_2D);
}
float Characters::ReturnInternalTime()
{
	return InternalTime;
}
void Characters::UpdateInternalTime(float amount)
{
	InternalTime+=amount;
}
void Characters::SetAnimationState(int whichstate)
{
	if(whichstate!=CurState)
	{
		SetAnim(whichstate);
		
		if(hasweapon==true)
		Weapon.SetAnim(whichstate);
	
		CurState=whichstate;
	}
}
bool Characters::Move(float amount)
{
	if((x+(float)cos(angle*0.017453292519943295769236907684886)*amount)<0||(x+(float)cos(angle*0.017453292519943295769236907684886)*amount)>250)
		return false;
	if((y+(float)sin(angle*0.017453292519943295769236907684886)*amount)<0||(y+(float)sin(angle*0.017453292519943295769236907684886)*amount)>250)
		return false;
	
	x+=(float)cos(angle*0.017453292519943295769236907684886)*amount;
	y+=(float)sin(angle*0.017453292519943295769236907684886)*amount;

	return true;

}