
#include"headers\\matrix.h"
Matrix::Matrix()
{
	settoidentiy();
}
Matrix::~Matrix()
{
}
void Matrix::settoidentiy()
{
	for(int y=0;y<4;y++)
		for(int x=0;x<4;x++)
		{
			Matrixd[y][x]=0;
		}
		Matrixd[0][0]=1;
		Matrixd[1][1]=1;
		Matrixd[2][2]=1;
		Matrixd[3][3]=1;
}
void Matrix::submatrix(float *mr,float *mb,int i, int j)
{
	int di, dj, si, sj;
	  // loop through 3x3 submatrix
	  for( di = 0; di < 3; di ++ ) {
	    for( dj = 0; dj < 3; dj ++ ) {
	      // map 3x3 element (destination) to 4x4 element (source)
	      si = di + ( ( di >= i ) ? 1 : 0 );
	      sj = dj + ( ( dj >= j ) ? 1 : 0 );
	      // copy element
	      mb[di * 3 + dj] = mr[si * 4 + sj];
		  mb[di * 3 + dj]=mb[di * 3 + dj];
	    }

	  }
}
float Matrix::det3x3(float*mat)
{
	float det;
      det = mat[0] * ( mat[4]*mat[8] - mat[7]*mat[5] )
          - mat[1] * ( mat[3]*mat[8] - mat[6]*mat[5] )
          + mat[2] * ( mat[3]*mat[7] - mat[6]*mat[4] );
      return( det );

}
float Matrix::det4x4(float*mr)
{
	  
      float   det, result = 0, i = 1;
      float msub3[9];
      int     n;
      for ( n = 0; n < 4; n++, i *= -1 )
        {

        submatrix( mr, msub3, 0, n );
        det     = det3x3( msub3 );
        result += mr[n] * det * i;
        }
      return( result );
     
}
void Matrix::inversematrix()
{
	  convertmatrix();
	  float tempsinglematrix[16];
	  for(int z=0;z<16;z++)
		  tempsinglematrix[z]=SinglecMatrix[z];
	  float  mdet = det4x4( tempsinglematrix );
      float mtemp[9];
      int     i, j, sign;
      if ( fabs( mdet ) < 0.0005 )
	  {
		  settoidentiy();
          return;
	  }
      for ( i = 0; i < 4; i++ )
        for ( j = 0; j < 4; j++ )
          {
          sign = 1 - ( (i +j) % 2 ) * 2;
          submatrix( tempsinglematrix, mtemp, i, j );
          SinglecMatrix[i+j*4] = ( det3x3( mtemp ) * sign ) / mdet;
          }
		reverseconvertmatrix();

}
void Matrix::invertmatrix()
{
	double temp[4][4];
	
	for(int y=0;y<4;y++)
		for(int x=0;x<4;x++)
			temp[x][y]=Matrixd[y][x];
		
		for(int y2=0;y2<4;y2++)
			for(int x2=0;x2<4;x2++)
				Matrixd[y2][x2]=temp[y2][x2];
}

void Matrix::convertmatrix()
{
	int i=0;
	for(int y=0;y<4;y++)
		for(int x=0;x<4;x++)
		{
			SinglecMatrix[i]=(float)Matrixd[y][x];
			i++;
		}
}
void Matrix::reverseconvertmatrix()
{
	int i=0;
	for(int y=0;y<4;y++)
		for(int x=0;x<4;x++)
		{
		Matrixd[y][x]=SinglecMatrix[i];
			i++;
		
		}
}
void Matrix:: printmatrix()
{
	for(int y=0;y<4;y++)
	{
		
		for(int x=0;x<4;x++)
			cout<<Matrixd[y][x]<<" ";
		cout<<endl;
	}
}
void Matrix::rotationmatrix(float anglex,float angley,float anglez)
{
	
	
	double A       = cos(anglex);
    double B       = sin(anglex);
    double C       = cos(angley);
    double D       = sin(angley);
    double E       = cos(anglez);
    double F       = sin(anglez);
	
    double AD      =   A * D;
    double BD      =   B * D;
	
    Matrixd[0][0]  =   C * E;
    Matrixd[0][1]  =  -C * F;
    Matrixd[0][2]  =   D;
    Matrixd[1][0]  =  BD * E + A * F;
    Matrixd[1][1]  = -BD * F + A * E;
    Matrixd[1][2]  =  -B * C;
    Matrixd[2][0]  = -AD * E + B * F;
    Matrixd[2][1]  =  AD * F + B * E;
    Matrixd[2][2] =   A * C;
	
	Matrixd[2][3]= Matrixd[1][3]  =Matrixd[0][3]= Matrixd[3][0]=Matrixd[3][1] = Matrixd[3][2] = 0;
    Matrixd[3][3] =  1;
	
}
void Matrix::multiplymatrixes(Matrix *Matrix1,Matrix *Matrix2)
{
	for(int y=0;y<4;y++)
		for(int x=0;x<4;x++)
			Matrixd[y][x]=0;
		
		for(int j=0;j<4;j++)
			for(int i=0;i<4;i++)
			{
				for(int x=0;x<4;x++)
					Matrixd[j][i]+=Matrix1->Matrixd[j][x]*Matrix2->Matrixd[x][i];
			}
}
