
#include "headers\\Shadow.h"
#include "headers\\landscape.h"

Shadow::Shadow(int Size,int SizeX, int SizeY)
{
	
	glActiveTextureARB = (PFNGLACTIVETEXTUREARBPROC)
        wglGetProcAddress("glActiveTextureARB");
    glMultiTexCoord2fARB = (PFNGLMULTITEXCOORD2FARBPROC)
        wglGetProcAddress("glMultiTexCoord2fARB");
    glMultiTexCoord3fARB = (PFNGLMULTITEXCOORD3FARBPROC)
        wglGetProcAddress("glMultiTexCoord3fARB");
	ShadowMapSize=Size;
	
	SX=SizeX;
	SY=SizeY;
	
	rt = new RenderTexture(Size, Size, true, true);
	rt->Initialize(true, true, false, true, true, 8, 8, 8, 8);
}
void Shadow::BeginGetShadowMap(float lightposx,float lightposy,float lightposz,double LightAngleX,double LightAngleZ)
{
	rt->BeginCapture();
	LightCam.CreateLightView(lightposx,lightposy,lightposz,LightAngleX,LightAngleZ);
	
	glEnable(GL_DEPTH_TEST);
	
	rt->EnableTextureTarget();
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(100,1,10,300.0);
	glGetFloatv(GL_MODELVIEW_MATRIX,LightMatrixPOV.SinglecMatrix);;
	LightMatrixPOV.reverseconvertmatrix();
	glGetFloatv(GL_PROJECTION_MATRIX,LightProjection.SinglecMatrix);
	LightProjection.reverseconvertmatrix();
	
	glMatrixMode(GL_MODELVIEW);
	//Use viewport the same size as the shadow map
	glViewport(0, 0, ShadowMapSize, ShadowMapSize);
	
	//Draw back faces into the shadow map
	glCullFace(GL_BACK);
	
	//Disable color writes, and use flat shading for speed
	glShadeModel(GL_FLAT);
	//	glColorMask(0, 0, 0, 0);
	glEnable(GL_POLYGON_OFFSET_FILL);
	glPolygonOffset(1.1, 2.0);
	
}
void Shadow::EndGetShadowMap()
{
	
	rt->EndCapture();
	glCullFace(GL_BACK);
	glShadeModel(GL_SMOOTH);
	glColorMask(1, 1, 1, 1);
	glViewport(0,0,SX,SY);
	
	GLfloat fAspect=SX/SY;
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(60,fAspect,0.1,400.0);
	glMatrixMode(GL_MODELVIEW);
	
	glDisable(GL_POLYGON_OFFSET_FILL);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_CULL_FACE);
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glClearColor(0,0,1,0);	
	
	LightCam.RestoreFromLightView();
	
}

void Shadow::EnableShadowMap()
{
	
	
	
	//Enable shadow comparison
	/*glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_MODE_ARB, GL_COMPARE_R_TO_TEXTURE_ARB);
	
	  //Shadow comparison should be true (ie not in shadow) if r<=texture
	  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_FUNC_ARB, GL_LEQUAL);
	  
		//Shadow comparison should generate an INTENSITY result
	glTexParameteri(GL_TEXTURE_2D, GL_DEPTH_TEXTURE_MODE_ARB, GL_INTENSITY);*/
	//glEnable(GL_ARB_shadow);
	rt->BindDepth();
	float st_scale_and_bias = 0.5f;
	glMatrixMode(GL_TEXTURE);
	glPushMatrix();
	glLoadIdentity();
	glTranslatef(st_scale_and_bias, st_scale_and_bias, 0.5f);
	glScalef(st_scale_and_bias, st_scale_and_bias, 0.5f);
	
	glMultMatrixf(LightProjection.SinglecMatrix);
	glMultMatrixf(LightMatrixPOV.SinglecMatrix);	
	
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_MODE_ARB, GL_COMPARE_R_TO_TEXTURE_ARB);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_FUNC_ARB, GL_LEQUAL);
	
}

void Shadow::DisableShadowMap()
{
	glMatrixMode(GL_TEXTURE);
	glPopMatrix();

}