
#include <gl/glew.h>
#include<gl/glut.h>
#include<gl/glext.h>
#include <gl/glaux.h>
#include<stdio.h>
#include<stdlib.h>
#include<windows.h>
#include<fstream.h>
#include<math.h>
#include<assert.h>
#include<fstream.h>

static PFNGLACTIVETEXTUREARBPROC glActiveTextureARB;
static PFNGLMULTITEXCOORD2FARBPROC glMultiTexCoord2fARB;
static PFNGLMULTITEXCOORD3FARBPROC glMultiTexCoord3fARB;

struct vertex{
	double x,y,z,u,v;
};
struct lighting{
vertex normal;
vertex stangent;
vertex ttangent;
};

#define SKYPOINTS 90
class CgShader;
class Landscape
{
private:
	Landscape();
	GLuint	terraintexture;
	GLuint	terraintexture2;
	GLuint  detailtexture;
	GLuint  grasstexture1;
	GLuint  grasstexture2;
	GLuint  grasstexture3;
	GLuint  CloudNoiseTexture;
	GLuint Landnum;
    GLuint Grassnum;
	GLuint Skynum1;
	GLuint Skynum2;
	float NoiseTextureData[256][256][4];
	float mf[512][512];
	lighting LightInfo[512][512];
	void ReadFractal(int Sizex,int Sizey,char *whichhieghtmap);
	void GenerateTangentSpace(const vertex &Vert1,const vertex &Vert2,const vertex &Vert3,vertex &norm, vertex &stan, vertex &ttan);
	void SetupTexture();
	void CreateLandscape();
	void CreateSkySpheres(float BaseRed=.1,float BaseGreen=.1,float BaseBlue=.2,float BlueScale=1);//The background texture would be better done on the GPU, but thats a little much for the target hardware
	void CreateGrass();
	float MoveRange(float x);
	
	AUX_RGBImageRec *TextureImage;//Texture0
	AUX_RGBImageRec *TextureImage2;//Texture1
	AUX_RGBImageRec *TextureImage3;//Detail Texture
	AUX_RGBImageRec *TextureImage4;//Grass
	AUX_RGBImageRec *TextureImage5;//Grass
	AUX_RGBImageRec *TextureImage6;//Grass
	char * LData;
	char * LTexture;
	char * LTexture2;
	char * LDetailTexture;
	int Sx;
	int Sy;
	vertex CrossProduct(vertex &v1,vertex &v2);
	void Normalize(vertex &v1);
	float InternalTime;


public:
	Landscape(char * LandscapeData,char * LandscapeTexture,char * LandscapeTexture2, char *LandscapeDetailTexture,int Sizex,int Sizey);
	void SetupGrassTexture(char * GrassTexture);
	void DrawSkySpheres();
	void DrawLandscape(bool ShadowMap);
	void UpdateInternalTime(float amount);
	float ReturnInternalTime();
	float ReturnHeight(float x, float y);
	CgShader *FragmentShader;
	CgShader *GrassFragmentShader;
	CgShader *VertexShader;
	CgShader *GrassVertexShader;
	
	~Landscape();
};