#include "headers\\landscape.h"
#include "headers\\Cg.h"
Landscape::Landscape(char * LandscapeData,char * LandscapeTexture, char * LandscapeTexture2,char *LandscapeDetailTexture,int Sizex, int Sizey)
{
	InternalTime=1;
	LData=LandscapeData;
	LTexture=LandscapeTexture;
	LTexture2=LandscapeTexture2;
	LDetailTexture=LandscapeDetailTexture;
	Sx=Sizex;
	Sy=Sizey;
		glActiveTextureARB = (PFNGLACTIVETEXTUREARBPROC)
        wglGetProcAddress("glActiveTextureARB");
    glMultiTexCoord2fARB = (PFNGLMULTITEXCOORD2FARBPROC)
        wglGetProcAddress("glMultiTexCoord2fARB");
    glMultiTexCoord3fARB = (PFNGLMULTITEXCOORD3FARBPROC)
        wglGetProcAddress("glMultiTexCoord3fARB");
	ReadFractal(Sx,Sy,LData);

	SetupTexture();
	VertexShader=new CgShader("Shaders\\LandscapeVertexShader.cg",true);
	VertexShader->GetDebugInfo();
	FragmentShader=new CgShader("Shaders\\LandscapeFragmentShader.cg",false);
	FragmentShader->GetDebugInfo();
	FragmentShader->SetTextureParameterValue("GrassTexture",terraintexture);
	FragmentShader->SetTextureParameterValue("DirtTexture",terraintexture2);
    FragmentShader->SetTextureParameterValue("DetailTexture",detailtexture);\
											
	for(int y=0;y<Sizey;y++)
		for(int x=0;x<Sizex;x++)
		{
			LightInfo[y][x].normal.x=0;
			LightInfo[y][x].normal.y=0;
			LightInfo[y][x].normal.z=0;
			LightInfo[y][x].stangent.x=0;
			LightInfo[y][x].stangent.y=0;
			LightInfo[y][x].stangent.z=0;
			LightInfo[y][x].ttangent.x=0;
			LightInfo[y][x].ttangent.y=0;
			LightInfo[y][x].ttangent.z=0;
		}
	CreateLandscape();
	CreateGrass();
	CreateSkySpheres();

}
Landscape::~Landscape()
{
	delete VertexShader;
	delete FragmentShader;
}
void Landscape::ReadFractal(int howx,int howy,char *whichhieghtmap)
{
	fstream file;
	file.open(whichhieghtmap,ios::in);
	for(int y=0;y<howx;y++)
		for(int x=0;x<howy;x++)
		{
			float it=0;
			file>>it;
			mf[y][x]=it;
		}
}
void  Landscape::SetupTexture()
{
	glActiveTextureARB(GL_TEXTURE0_ARB);
	glEnable(GL_TEXTURE_2D);
	TextureImage=auxDIBImageLoad(LTexture);
	glGenTextures(1,&terraintexture);
	glBindTexture(GL_TEXTURE_2D, terraintexture);
	glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage->sizeX, TextureImage->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage->data);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);	
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	

	glActiveTextureARB(GL_TEXTURE1_ARB);
	TextureImage2=auxDIBImageLoad(LTexture2);
	glGenTextures(1,&terraintexture2);
	glBindTexture(GL_TEXTURE_2D, terraintexture2);
	glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage2->sizeX, TextureImage2->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage2->data);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);	
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	

	glActiveTextureARB(GL_TEXTURE2_ARB);
	TextureImage3=auxDIBImageLoad(LDetailTexture);
	glGenTextures(1,&detailtexture);
	glBindTexture(GL_TEXTURE_2D, detailtexture);
	glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage3->sizeX, TextureImage3->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage3->data);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);	
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	


}

vertex Landscape::CrossProduct(vertex &v1,vertex &v2)
{
	vertex temp;
	temp.x=v1.y*v2.z-v1.z*v2.y;
	temp.y=v1.x*v2.z-v1.z*v2.x;
	temp.z=v1.x*v2.y-v1.y*v2.x;
	return temp;

}
void Landscape::Normalize(vertex &v1)
{

	float size=sqrt(v1.x*v1.x+v1.y*v1.y+v1.z*v1.z);
	v1.x=v1.x/size;
	v1.y=v1.y/size;
	v1.z=v1.z/size;
	
}

void Landscape::GenerateTangentSpace(const vertex &Vert1,const vertex &Vert2,const vertex &Vert3,vertex &norm, vertex &stan, vertex &ttan)
{
	vertex side0;
	vertex side1;

	side0.x=Vert1.x-Vert2.x;
	side0.y=Vert1.y-Vert2.y;
	side0.z=Vert1.z-Vert2.z;

	side1.x=Vert3.x-Vert2.x;
	side1.y=Vert3.y-Vert2.y;
	side1.z=Vert3.z-Vert2.z;

	norm=CrossProduct(side1,side0);

	Normalize(norm);


	float deltaT0=Vert1.v-Vert2.v;
	float deltaT1=Vert3.v-Vert2.v;


	stan.x=deltaT1*side0.x-deltaT0*side1.x;
	stan.y=deltaT1*side0.y-deltaT0*side1.y;
	stan.z=deltaT1*side0.z-deltaT0*side1.z;
	Normalize(stan);


	float deltaS0=Vert1.u-Vert2.u;
	float deltaS1=Vert3.u-Vert2.u;
	ttan.x=deltaS1*side0.x-deltaS0*side1.x;
	ttan.y=deltaS1*side0.y-deltaS0*side1.y;
	ttan.z=deltaS1*side0.z-deltaS0*side1.z;

	Normalize(ttan);

	vertex cnorm=CrossProduct(stan,ttan);

	if((cnorm.x*norm.x+cnorm.y*norm.y+cnorm.z*norm.z)<0)
	{
		stan.x=-stan.x;
		stan.y=-stan.y;
		stan.z=-stan.z;

		ttan.x=-ttan.x;
		ttan.y=-ttan.y;
		ttan.z=-ttan.z;
	}
}
float Landscape::MoveRange(float x)
{
	return (x/2+.5);
}

void Landscape::CreateSkySpheres(float BaseRed,float BaseGreen,float BaseBlue,float BlueScale)
{

	Skynum1=glGenLists(1);
	glNewList(Skynum1,GL_COMPILE);
	glBegin(GL_TRIANGLE_STRIP);

	float nStep = 6.283185307179586476925286766559/SKYPOINTS;
	float fx=0;
	float fy=0;
	double horizontal=0;

	for( float n = 0; n  <= SKYPOINTS/2+1; n++ )	
	{
		
		for (float p = 0; p <= SKYPOINTS; p++ )	
		{
			
			horizontal	=  sin(fy);	
		
			glColor3f(BaseRed,BaseGreen,BaseBlue+((BlueScale*n)/(SKYPOINTS/2+1)));
			glVertex3f( (horizontal * sin(fx))*10,(cos(fy))*10, (horizontal * cos(fx))*10);
			
		
	
		
		
			fy-=nStep;
			glColor3f(BaseRed,BaseGreen,BaseBlue+((BlueScale*n+1)/(SKYPOINTS/2+1)));
			horizontal	=  sin(fy);	
			glVertex3f((horizontal * sin(fx))*10,(cos(fy))*10,(horizontal * cos(fx))*10);
			
		
		
			fx-=nStep;
			
			fy+=nStep;

		}
		fx=0;
		fy-=nStep;
		
		
	}
	glEnd();
	glEndList();



	
}

void Landscape::CreateLandscape()
{
	Landnum=glGenLists(1);
	glNewList(Landnum,GL_COMPILE);
		glBegin(GL_QUADS);
	
	float width=Sx;
	float length=Sy;
	float texstepx=1/(length);
	float texstepy=1/(width);
	float texy=0;
	///Generate Lighting info(Normals, and Tangent Vectors
	for(int y=0;y<length-1;y++)
	{	float texx=0;
		for(int x=0;x<width-1;x++)
		{
			vertex tempnorm;
			vertex tempstan;
			vertex tempttan;
			//
		

			vertex x1={x,y,mf[y][x],texx,texy};
			vertex x2={x,(y+1),mf[y+1][(x)],texx,texy+texstepy};
			texx+=texstepx;
			vertex x3={(x+1),(y+1),mf[(y+1)][(x+1)],texx,texy};
			GenerateTangentSpace(x3,x2,x1,tempnorm,tempstan,tempttan);
			//
			LightInfo[y][x].normal.x+=tempnorm.x;
			LightInfo[y][x].normal.y+=tempnorm.y;
			LightInfo[y][x].normal.z+=tempnorm.z;
			LightInfo[y][x].stangent.x+=tempstan.x;
			LightInfo[y][x].stangent.y+=tempstan.y;
			LightInfo[y][x].stangent.z+=tempstan.z;
			LightInfo[y][x].ttangent.x+=tempttan.x;
			LightInfo[y][x].ttangent.y+=tempttan.y;
			LightInfo[y][x].ttangent.z+=tempttan.z;
			//
			vertex x4={x,y,mf[y][x],texx-=texstepx,texy};
			vertex x5={(x+1),y,mf[(y)][x+1],texx,texy};
			vertex x6={(x+1),(y+1),mf[(y+1)][(x+1)],texx,texy+texstepy};
			GenerateTangentSpace(x4,x5,x6,tempnorm,tempstan,tempttan);
			//
			LightInfo[y+1][x+1].normal.x+=tempnorm.x;
			LightInfo[y+1][x+1].normal.y+=tempnorm.y;
			LightInfo[y+1][x+1].normal.z+=tempnorm.z;
			LightInfo[y+1][x+1].stangent.x+=tempstan.x;
			LightInfo[y+1][x+1].stangent.y+=tempstan.y;
			LightInfo[y+1][x+1].stangent.z+=tempstan.z;
			LightInfo[y+1][x+1].ttangent.x+=tempttan.x;
			LightInfo[y+1][x+1].ttangent.y+=tempttan.y;
			LightInfo[y+1][x+1].ttangent.z+=tempttan.z;
			//
		}
			texy+=texstepy;
	}
	for(y=0;y<length-1;y++)
		for(int x=0;x<width-1;x++)
		{
			Normalize(LightInfo[y][x].normal);
			Normalize(LightInfo[y][x].stangent);
			Normalize(LightInfo[y][x].ttangent);
		}
	///Generate Landscape Geo..
		texy=0;
	for(int i=0;i<length-1;i++)
	{
		float texx=0;
		for(int i2=0;i2<width-1;i2++)
		{
			vertex x1={i2,i,mf[i][i2]};
			vertex x2={i2,(i+1),mf[i+1][(i2)]};
			vertex x3={(i2+1),(i+1),mf[(i+1)][(i2+1)]};
			vertex x4={(i2+1),i,mf[(i)][i2+1]};
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,texx,texy);
			glNormal3f(LightInfo[i][i2].normal.x,LightInfo[i][i2].normal.y,LightInfo[i][i2].normal.z);
			glMultiTexCoord3fARB(GL_TEXTURE1_ARB,LightInfo[i][i2].stangent.x,LightInfo[i][i2].stangent.y,LightInfo[i][i2].stangent.z);
			glMultiTexCoord3fARB(GL_TEXTURE2_ARB,LightInfo[i][i2].ttangent.x,LightInfo[i][i2].ttangent.y,LightInfo[i][i2].ttangent.z);
			glColor3f(x1.z/7.2+.5,x1.z/7.2+.5,x1.z/7.2+.5);
			glVertex3f(x1.x,x1.z-5,x1.y);
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,texx,texy+texstepy);
			texx+=texstepx;
			glColor3f(	x2.z/7.2+.5,x2.z/7.2+.5,x2.z/7.2+.5);
			glNormal3f(LightInfo[i+1][i2].normal.x,LightInfo[i+1][i2].normal.y,LightInfo[i+1][i2].normal.z);
			glMultiTexCoord3fARB(GL_TEXTURE1_ARB,LightInfo[i+1][i2].stangent.x,LightInfo[i+1][i2].stangent.y,LightInfo[i+1][i2].stangent.z);
			glMultiTexCoord3fARB(GL_TEXTURE2_ARB,LightInfo[i+1][i2].ttangent.x,LightInfo[i+1][i2].ttangent.y,LightInfo[i+1][i2].ttangent.z);
			glVertex3f(x2.x,x2.z-5,x2.y);
			glColor3f(	x3.z/7.2+.5,x3.z/7.2+.5,x3.z/7.2+.5);
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,texx,texy+texstepy);
			glNormal3f(LightInfo[i+1][i2+1].normal.x,LightInfo[i+1][i2+1].normal.y,LightInfo[i+1][i2+1].normal.z);
			glMultiTexCoord3fARB(GL_TEXTURE1_ARB,LightInfo[i+1][i2+1].stangent.x,LightInfo[i+1][i2+1].stangent.y,LightInfo[i+1][i2+1].stangent.z);
			glMultiTexCoord3fARB(GL_TEXTURE2_ARB,LightInfo[i+1][i2+1].ttangent.x,LightInfo[i+1][i2+1].ttangent.y,LightInfo[i+1][i2+1].ttangent.z);
			glVertex3f(x3.x,x3.z-5,x3.y);
			glColor3f(	x4.z/7.2+.5,x4.z/7.2+.5,x4.z/7.2+.5);
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,texx,texy);
			glNormal3f(LightInfo[i][i2+1].normal.x,LightInfo[i][i2+1].normal.y,LightInfo[i][i2+1].normal.z);
			glMultiTexCoord3fARB(GL_TEXTURE1_ARB,LightInfo[i][i2+1].stangent.x,LightInfo[i][i2+1].stangent.y,LightInfo[i][i2+1].stangent.z);
			glMultiTexCoord3fARB(GL_TEXTURE2_ARB,LightInfo[i][i2+1].ttangent.x,LightInfo[i][i2+1].ttangent.y,LightInfo[i][i2+1].ttangent.z);
			glVertex3f(x4.x,x4.z-5,x4.y);
			
		}
		texy+=texstepy;
		
	}
		glEnd();
	
	

	glEndList();
}

void Landscape::SetupGrassTexture(char * GrassTexture)
{
	glActiveTextureARB(GL_TEXTURE0_ARB);
	glEnable(GL_TEXTURE_2D);
	TextureImage4=auxDIBImageLoad(GrassTexture);
	glGenTextures(1,&grasstexture1);
	glBindTexture(GL_TEXTURE_2D, grasstexture1);
	unsigned char *texturedata;
	texturedata=new unsigned char [TextureImage4->sizeX*TextureImage4->sizeY*4];
	int k=0;
	for( int i=0;i<(TextureImage4->sizeX*TextureImage4->sizeY)*4;i)
	{
		texturedata[i]=TextureImage4->data[k];
		i++;
		k++;
		texturedata[i]=TextureImage4->data[k];
		i++;
		k++;
		texturedata[i]=TextureImage4->data[k];
		i++;
		k++;
		texturedata[i]=255-TextureImage4->data[k-2];
		i++;
	}

	glTexImage2D(GL_TEXTURE_2D, 0, 4, TextureImage4->sizeX, TextureImage4->sizeY, 0, GL_RGBA, GL_UNSIGNED_BYTE,texturedata);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);	
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	
	///

	GrassFragmentShader=new CgShader("Shaders\\GrassFragmentShader.cg",false);
	GrassFragmentShader->GetDebugInfo();
	GrassFragmentShader->SetTextureParameterValue("Grass",grasstexture1);
	GrassFragmentShader->GetDebugInfo();
	GrassVertexShader=new CgShader("Shaders\\GrassVertexShader.cg",true);
	GrassVertexShader->GetDebugInfo();


}
void Landscape::CreateGrass()
{
	float epsy=3;
	int numgrass=10000;
	Grassnum=glGenLists(1);
	glNewList(Grassnum,GL_COMPILE);
	

			
		
		for(int i=0;i<numgrass;i++)
		{
				int randposy;
				int randposx;
				do{
			     randposy=rand()%(Sx-20);
				 randposx=rand()%(Sy-20);
				}while(mf[randposy][randposx]>-1.5);
				int directionx=rand()%2;
				int directiony=rand()%2;
				glBegin(GL_QUAD_STRIP);
				int lengthofgrass=5;
				float lengthoftextureu=(1/(float)lengthofgrass);
				for(int j=0;j<lengthofgrass;j++)
				{
					
					glMultiTexCoord2fARB(GL_TEXTURE0_ARB,lengthoftextureu*j,0);
					glMultiTexCoord2fARB(GL_TEXTURE1_ARB,0,0);
					glVertex3f(randposx,mf[randposy][randposx]-5,randposy);
					glMultiTexCoord2fARB(GL_TEXTURE0_ARB,lengthoftextureu*j,.9);
					glMultiTexCoord2fARB(GL_TEXTURE1_ARB,1,0);
					float randh=(rand()%8);
					float modifier=(epsy+randh)/3.5;
					glVertex3f(randposx,mf[randposy][randposx]-5+modifier,randposy);
					randposy+=directiony;
					randposx+=directionx;

				}
				glEnd();

		}		
				
			
	
	
	glEndList();
}
void Landscape::DrawSkySpheres()
{

	glClear(GL_COLOR_BUFFER_BIT);
	glDisable(GL_DEPTH_TEST);
	glCallList(Skynum1);
	glEnable(GL_TEXTURE_2D);
	glActiveTextureARB(GL_TEXTURE0_ARB);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glBindTexture(GL_TEXTURE_2D, CloudNoiseTexture);	
//	glCallList(Skynum2);
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_DEPTH_TEST);

}
void Landscape::DrawLandscape(bool ShadowMap)
{
	if(ShadowMap==false)
	{
	VertexShader->BindProgram();
	FragmentShader->BindProgram();
	glCallList(Landnum);
	VertexShader->DisableProfile();
	FragmentShader->DisableProfile();
	GrassFragmentShader->BindProgram();
	GrassVertexShader->BindProgram();
	GrassVertexShader->SetProgramParameterValue1("Time",&InternalTime);
	glAlphaFunc(GL_LESS ,.8);
	glEnable(GL_ALPHA_TEST);
	glDisable(GL_CULL_FACE);
	glCallList(Grassnum);
	glDisable(GL_ALPHA_TEST);
	GrassFragmentShader->DisableProfile();
	GrassVertexShader->DisableProfile();
	}
	else
	{
	glDisable(GL_TEXTURE_2D);
	VertexShader->DisableProfile();
	FragmentShader->DisableProfile();
	//glCallList(Landnum);//Decomment this if you want the land to cast shadows
 	GrassFragmentShader->BindProgram();
	GrassVertexShader->BindProgram();
	GrassVertexShader->SetProgramParameterValue1("Time",&InternalTime);
	glAlphaFunc(GL_LESS ,.8);
	glEnable(GL_ALPHA_TEST);
	glActiveTextureARB(GL_TEXTURE0_ARB);
	glBindTexture(GL_TEXTURE_2D, grasstexture1);
	glDisable(GL_CULL_FACE);
	glCallList(Grassnum);
	glDisable(GL_ALPHA_TEST);
	GrassFragmentShader->DisableProfile();
	GrassVertexShader->DisableProfile();
	}
}
void Landscape::UpdateInternalTime(float amount)
{
	InternalTime+=amount;
}
float Landscape::ReturnInternalTime()
{
	return InternalTime;
}
float Landscape::ReturnHeight(float x,float y)
{
	if(fabs(x)>250||fabs(y)>250)
		return 0;

	return ((mf[(int)ceil(x)][(int)ceil(y)]+mf[(int)floor(x)][(int)floor(y)]+mf[(int)floor(x)][(int)ceil(y)]+mf[(int)ceil(x)][(int)floor(y)])/4);
}