#include "headers\\landscape.h"
#include "headers\\Shadow.h"
#include "headers\\Cg.h"
#include "headers\\Characters.h"
#include "headers\\Engine.h"


Characters *Ogre;
Landscape* Land;
Shadow* Shadowmap;
Camera Cam;


GLuint	texturest;

float lvx=1;
float lvy=-10;
float lvz=1;
float rotate=1;
void RenderScene(void) {	
	

	
	Shadowmap->BeginGetShadowMap(lvx,lvy,lvz,0,2.3);
	

	Land->DrawLandscape(true);
	
	
	Ogre->z=Land->ReturnHeight(Ogre->y,Ogre->x);
	Ogre->Render();
	

	Shadowmap->EndGetShadowMap();
	
	
	
	
	Cam.UpdateCamera();
	
	Cam.KeepCentered();
	Land->DrawSkySpheres();
	Cam.RestoreFromLightView();
	
	
	Ogre->z=Land->ReturnHeight(Ogre->x,Ogre->y);
	Ogre->Render();

	
	Shadowmap->EnableShadowMap();
	
	Land->DrawLandscape(false);
	
	Shadowmap->DisableShadowMap();
	glMatrixMode(GL_MODELVIEW);
	
	
	
	glutSwapBuffers();
	
}

void Key( unsigned char key, int x, int y )
{
	
	if(key=='w')
	{
		Cam.MoveCamera(1);
	}
	if(key=='s')
	{
		Cam.MoveCamera(-1);	
	}
	if(key=='a')
	{
		Cam.TurnCamera(0,-1);
	}
	if(key=='d')
	{
		Cam.TurnCamera(0,1);	
	}
	
	
	if(key=='y')
	{
		
		Ogre->Move(1);
		Ogre->SetAnimationState(RUN);
		
	}
	if(key=='h')
	{
		Ogre->Move(-1);
		Ogre->SetAnimationState(RUN);
	}
	if(key=='g')
	{
		Ogre->angle+=5;
	
	}
	if(key=='j')
	{
		Ogre->angle-=5;
	
	}
	
	
	if(key=='o')
	{
		lvy+=1;	
	}
	if(key=='p')
	{
		lvy-=1;	
	}
	

}

void KeyUp( unsigned char key, int x, int y )
{
	if(key=='y')
	{
		Ogre->SetAnimationState(STAND);
	}
	if(key=='h')
	{
		Ogre->SetAnimationState(STAND);
	}
	if(key=='g')
	{
		Ogre->SetAnimationState(STAND);
	}
	if(key=='j')
	{
		Ogre->SetAnimationState(STAND);
	}
}
float gbutton=0;  
void Mouse( int button, int state, int x, int y)
{
	gbutton=button;
	
}
int oldx=0;
int oldy=0;
void PassiveMouseMove(int x,int y)
{
	oldx=x;
	oldy=y;
	
}
void MouseMove(int x, int y)
{
	
	if(gbutton==2)
	{
		if(oldy!=y)
			Cam.TurnCamera((float)(y-oldy),0);
		if(oldx!=x)
			Cam.TurnCamera(0,(float)(x-oldx));
		
		
	}
	oldx=x;
	oldy=y;
}
void TimerFunction(int value)
{
	Land->UpdateInternalTime(.05);
	Ogre->UpdateInternalTime(.05);
	RenderScene();
	glutTimerFunc(5,TimerFunction,1);
}
int const ScreenResX=1024;
int const ScreenResY=768;
bool const FullScreen=false;
void main()
{
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGBA|GLUT_DEPTH);
	glutInitWindowPosition(0,0);
	glutInitWindowSize(ScreenResX,ScreenResY);
	
	glutCreateWindow("Aldune");
	int err = glewInit();
	if (GLEW_OK != err)
	{
		fprintf(stderr, "GLEW Error: %s\n", glewGetErrorString(err));
		exit(-1);
	}	  
	glEnable(GL_DEPTH_TEST); 
	
	
	Shadowmap=new Shadow(2048,ScreenResX,ScreenResY);
	if(FullScreen==true)
		glutFullScreen();
	
	glClearColor(0,0,1,0);
	GLfloat fAspect=ScreenResX/ScreenResY;
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(60,fAspect,0.1,400.0);
	glMatrixMode(GL_MODELVIEW);
	
	
	
	Land=new Landscape("Aldune.raw","Textures\\LandTexture0.bmp","Textures\\LandTexture1.bmp","Textures\\Detail.bmp",256,256);
	Land->SetupGrassTexture("Textures\\GrassTexture.bmp");
	Land->FragmentShader->SetTextureParameterValue("ShadowMap", Shadowmap->rt->GetDepthTextureID());
	Ogre=new Characters("Models\\tris.md2","Textures\\dragon_yellow.bmp");
	Ogre->LoadWeapon("Models\\weapon.md2","Textures\\knight.bmp");
	Ogre->x=20;
	Ogre->y=20;
	Ogre->angle=45;
	
	glutDisplayFunc(RenderScene);
	glutKeyboardFunc(Key);
	glutKeyboardUpFunc(KeyUp);
	glutMouseFunc(Mouse);
	glutMotionFunc(MouseMove);
	glutPassiveMotionFunc(PassiveMouseMove);
	glutTimerFunc(5,TimerFunction,1);
	glutMainLoop();
}